<?php

namespace Teknisa\DF\Factories;

use Doctrine\ORM\EntityManager;

class RegrasTributariasFactory
{
    private $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }
    
    public function getCodProd($nrorg, $idcenario) {
        $sql = "SELECT *
            FROM SYS_MATERIAL
            WHERE NRORG = :P_NRORG
            AND ID_CENARIO = :P_IDCENARIO";
            
        $params = array(
            "P_NRORG" => $nrorg,
            "P_IDCENARIO" => $idcenario
        );
                
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    
    public function save_material($nrorg, $idcenario, $cod_prod, $idativo) {
        $sql = 
            "UPDATE SYS_MATERIAL
            SET IDATIVO = :P_IDATIVO
            WHERE  NRORG = :P_NRORG
            AND ID_CENARIO = :P_IDCENARIO
            AND COD_PROD = :P_COD_PROD";
            
        $params = array(
            "P_NRORG" => $nrorg,
            "P_IDCENARIO" => $idcenario,
            "P_COD_PROD" => $cod_prod,
            "P_IDATIVO" => $idativo
        );
            
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute($params);
        return $cod_prod;
    }


}