<?php

namespace Teknisa\DF\Modules\Saida\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\DF\Modules\Saida\Factories\Dfs88000ConhecimentoTransporteEletronicoFactory;

class Dfs88000ConhecimentoTransporteEletronicoService {
    protected $environment;
    protected $Dfs88000ConhecimentoTransporteEletronicoFactory;
    
    public function __construct($environment, EntityManager $entityManager, Dfs88000ConhecimentoTransporteEletronicoFactory $Dfs88000ConhecimentoTransporteEletronicoFactory) {
        $this->environment = $environment;
        $this->entityManager = $entityManager;
        $this->Dfs88000ConhecimentoTransporteEletronicoFactory = $Dfs88000ConhecimentoTransporteEletronicoFactory;
    }
    
    public function getDefaultFilterCTE($row) {
        $cdfilial = ($this->environment->getCdFilial() ) ? $this->environment->getCdFilial() : $row["CDFILIAL"];
        
        $paramfilial = $this->getParamFilial($cdfilial);
        $IDUTILDTPROC = $this->getParamGeral()->getIdutildtproc();
        
        if($IDUTILDTPROC ==='S') {
            
            $dtprocessamento = $paramfilial->getDtprocessa();
            if(isset($dtprocessamento)  && $dtprocessamento != null){
               $dtprocessamento =  $dtprocessamento->format('d/m/Y');
            } else {
                $dtprocessamento = date('d/m/Y');
            }
        } else {
            $dtprocessamento = date('d/m/Y');
        }
        
        $defaultFilter["DTEMISSAODEFAULT"] = $dtprocessamento;
        
        return $defaultFilter;
    }
    

    
    /**
     * Retorna os dados padrão para o CT-e de acordo com a empresa
     * 
     * @param string $cdEmpresa - Empresa
     * @param string $cdInscesta - Inscrição Estadual
     * 
     * return array - Dados default do CT-e
     */
    public function getDefaultCte($cdEmpresa, $cdInscesta) {
        return $this->Dfs88000ConhecimentoTransporteEletronicoFactory->getDefaultCte($cdEmpresa, $cdInscesta);
    }
    
    private function getParamFilial($cdfilial) {
       return  $this->entityManager->getRepository('Geral\Entities\Paramfilial') -> findOneBy( array('nrorg' => $this->environment->getNrOrgTrab(), 'cdfilial' => $cdfilial) );
    }
    
    private function getParamGeral() {
        return  $this->entityManager->getRepository('Teknisa\Model\Geral\Entities\Paramgeral') -> findOneBy( array('nrorg' => $this->environment->getNrOrgTrab() ) );
    }
}